#
#       $Torped: EasyImage.py,v 1.4.31 2001/09/29 12:00:00 lennart Exp $
#
# Easy Publisher Licens Version 1.0
# Upphovsrtt tillskrivs Torped Strategi och Kommunikation AB.
# Copyright Torped Strategi och Kommunikation AB.
#
# Denna licens reglerar nyttjandertt till Easy Publisher inklusive
# modifikationer, anpassningar och tillggsapplikationer (Systemet)
# tillhandahllet av Torped Strategi och Kommunikation AB till
# bestllaren (Licensinnehavaren). Genom att Licensinnehavaren
# installerar eller p annat stt anvnder Systemet accepterar
# Licensinnehavaren dessa licensvillkor och detta Licensavtal blir
# drigenom bindande fr Licensinnehavaren.
#
# Licensinnehavaren erhller genom denna licens en icke-exklusiv och
# icke-verltbar rtt att fr eget bruk nyttja, ndra, modifiera
# och vidareutveckla Systemet frutsatt att nedanstende villkor
# uppfylls. Licensinnehavaren erhller tillgng till, men dock ingen
# gandertt till, Systemets programkod, dvs kll- eller objektkod.
#
# 1.  Kllkod, binrer och systemdokumentation mste innehlla en
#     kopia av detta licensavtal samt Zope Public License (ZPL).
# 2.  Det r ej tilltet fr Licensinnehavaren att distribuera, hyra
#     ut, leasa ut, lna ut eller frslja Systemet inklusive
#     dokumentation, kllkod och binrer innefattade av denna licens
#     utan skriftligt tillstnd av Torped Strategi och Kommunikation AB.
# 3.  Anpassningar och utveckling av Systemet uppmuntras, men alla
#     anpassningar utvecklade under denna licens mste innefattas av
#     denna licens om inget annat skriftligen verenskommits med Torped
#     Strategi och Kommunikation AB.
# 4.  Licensinnehavaren har rtt att fritt nyttja och utveckla
#     Systemet fr eget bruk. Licensinnehavaren ger dock inte rtt att
#     verlta Systemets programkod, vare sig i delar eller dess helhet.
#     Det innebr vidare att Torped Strategi och Kommunikation AB ger
#     rtten till programkoden och har sledes rtt att upplta
#     programkoden ven till annan. Torped Strategi och Kommunikation AB
#     ger dock inte rtt att till annan upplta sdan programkod som
#     innehller grafisk utformning eller immateriella rttigheter som
#     tillhr Licensinnehavaren.
#
# I samband med fusion eller omstrukturering av Licensinnehavarens
# organisation kan Torped Strategi och Kommunikation AB utfrda nya
# licenser fr av Torped Strategi och Kommunikation AB driftsatta
# system.
#
# Torped Strategi och Kommunikation AB har rtt att sga upp detta
# Licensavtal om Licensinnehavaren bryter mot ngot av
# licensvillkoren. I sdant fall mste Licensinnehavaren
# avinstallera och frstra samtliga exemplar av Systemet och
# samtliga dess komponenter.
#
# Med undantag fr vad som srskilt och skriftligen verenskommits
# med Licensinnehavaren samt vad som fljer av tvingande lag,
# friskriver sig Torped Strategi och Kommunikation AB frn
# garantiansvar.
#

__doc__="""EasyImage Object

$Torped: EasyImage.py,v 1.4.31 2001/09/29 12:00:00 lennart Exp $"""
__version__='$Revision: 1.4.31 $'[11:-2]


import Globals
from Globals import DTMLFile
import string
from OFS.Image import Image, Pdata, getImageInfo
try:
    from Products.EasyWorkflow.EasyWorkflowBase import NullDate
    from Products.EasyResources.EasyResource import EasyResource
    from Products.EasyWorkflow.EasyWorkflowBase import NullDate
    from Products.EasyDublinCore.EasyDublinCore import EasyDublinCore
    from Products.EasySecurity.EasyCorePermissions import *
    _EP_is_present = 1
    class ImageClassProxy(EasyResource, EasyDublinCore, Image):
        pass
except: 
    # Running in a  non EasyPublisher environment:
    _EP_is_present = 0
    EasyImageAdd = 'Easy Image Add'
    class ImageClassProxy(Image):
        pass

    
from ComputedAttribute import ComputedAttribute
from webdav.common import rfc1123_date
import os
try:
    import PIL
    import PIL.PngImagePlugin
    import PIL.ImageFile
    PIL.ImageFile.MAXBLOCK = 1000000 # default is 64k
    from StringIO import StringIO
    _PIL_is_present = 1
except:
    _PIL_is_present = 0

bad_chars =  ' ,;()[]{}ݟ'
good_chars = '_________AAAAAAaaaaaaCcEEEEEeeeeeIIIIiiiiNnOOOOOOooooooSssUUUUuuuuYYyyZz'
TRANSMAP = string.maketrans(bad_chars, good_chars)

# This maps a content type to an internal type.
CONTENTTYPEMAP = { 'image/pjpeg':   'JPEG',     #Progressive JPEG
                   'image/jpeg':    'JPEG', 
                   'image/bmp':     'BMP',  
                   'image/png':     'PNG',
                   'image/gif':     'GIF',
                   'image/tif':     'TIFF',
                 } 

# This contains info on each internal type. (display-name, extension, content_type)
TYPEINFOMAP =  { 'JPEG':     { 'name':'JPEG', 'content_type': 'image/jpeg', }, 
                 'GIF':      { 'name':'GIF',  'content_type': 'image/gif', }, 
                 'BMP':      { 'name':'BMP',  'content_type': 'image/bmp', }, 
                 'PNG':      { 'name':'PNG',  'content_type': 'image/png', }, 
                 'TIFF':     { 'name':'TIFF', 'content_type': 'image/tif', }, 
               }
                 
# This map show possible conversions from each internal type:
CONVERSIONMAP = { 'JPEG': ('PNG', 'TIFF', 'BMP'),
                  'GIF':  ('JPEG', 'PNG', 'TIFF', 'BMP'),
                  'BMP':  ('JPEG', 'PNG', 'TIFF',),
                  'PNG':  ('JPEG', 'TIFF', 'BMP'),
                  'TIFF': ('JPEG', 'PNG', 'BMP',),
                }
                   

class EasyImage(ImageClassProxy):
    """A EasyImage Object """

    meta_type = 'EasyImage'

    description = ""
    keywords = ""
    category = ""

    manage_options_image = ({'label':'Edit',            'action': 'manage_main'       },
                            {'label':'View/Download',   'action': 'view_image_or_file'}, )
    
    manage_options_convertresize = ({'label':'Convert/Resize',  'action': 'manage_convertResizeForm'},)

    manage_options_inherited =  Image.manage_options[2:]

    if _PIL_is_present == 1:
        manage_options = manage_options_image + manage_options_convertresize + manage_options_inherited
    else:
        manage_options = manage_options_image + manage_options_inherited

    def __init__(self, id, file, title=''):
        if _EP_is_present: EasyDublinCore.__init__(self)
        Image.__init__(self, id, title, file)
        self.originaldata = None


    def getImageInfoPIL(self, data):
        file = StringIO(str(data))
        im = PIL.Image.open(file)
        size = im.size
        print "DEBUG: ", im.format
        ct = TYPEINFOMAP[im.format]['content_type']
        return ct, size[0], size[1]
    
    
    def update_data(self, data, content_type=None, size=None):
        if size is None: size=len(data)

        self.size=size
        self.data=data

        if _PIL_is_present == 0:
                ct, width, height = getImageInfo(data)
        else:
                ct, width, height = self.getImageInfoPIL(data)        
        
        if ct:
            content_type = ct
        if width >= 0 and height >= 0:
            self.width = width
            self.height = height

        # Now we should have the correct content type, or still None
        if content_type is not None: self.content_type = content_type

        self.ZCacheable_invalidate()

    def manage_upload(self,file='',REQUEST=None):
        """
        Replaces the current contents of the File or Image object with file.

        The file or images contents are replaced with the contents of 'file'.
        """
        Image.manage_upload(self, file, REQUEST)
        
        self.orig_data = None
        self.orig_height = self.orig_width = self.orig_size = 0
        self.prev_data = None
        self.prev_height = self.prev_width = self.prev_size = 0
        
        self.manage_create_prev()
        
        if REQUEST is not None:
            message = "Image Uploaded"
            return self.manage_editForm(
                self,
                REQUEST,
                manage_tabs_message=message,
                management_view='Edit')
        return id
        

    def manage_create_prev(self, REQUEST=None):
        """Creates the preview"""
        
        # Find the default preview setting, or if it doesn't have one use 100
        EE = getattr(self, 'EasyEditor', None)
        if EE == None:
            ER = None
        else:
            try: # TODO: I think getEasyResources() should return None, instead of raising an exception.
                ER = EE.getEasyResources()
            except:
                ER = None
    
        if ER == None:
            maxx = maxy = 100
            create_prev = 1
        else:
            maxy = getattr(ER, 'default_preview_height', 100)
            maxx = getattr(ER, 'default_preview_width', 100)
            create_prev = getattr(ER, 'default_preview_create', 1)
        
        if _PIL_is_present == 0:
            create_prev = 0
        
        if create_prev:
            self.prev_data, self.prev_type, self.prev_width, self.prev_height = \
                self.makeimage( maxx, maxy)
            self.prev_size = len(self.prev_data)
            if self.prev_size <> 0:
                self.has_preview = 1
        else:
            self.manage_del_prev()
            
        if REQUEST is not None:
            message = "Preview created"
            return self.manage_editForm(
                self,
                REQUEST,
                manage_tabs_message=message,
                management_view='Edit')
        return id
        
    def manage_del_prev(self, REQUEST=None):
        """Deletes the preview image"""
        self.has_preview = 0
        self.prev_size = 0
        self.prev_type = ''
        self.prev_data = None
        self.prev_height = 0
        self.prev_width = 0
        
        if REQUEST is not None:
            message = "Preview deleted"
            return self.manage_editForm(
                self,
                REQUEST,
                manage_tabs_message=message,
                management_view='Edit')
        return id

    
    def set_header(self, REQUEST, RESPONSE, content_type, size):
        # HTTP If-Modified-Since header handling.
        header=REQUEST.get_header('If-Modified-Since', None)
        if header is not None:
            header=string.split(header, ';')[0]
            # Some proxies seem to send invalid date strings for this
            # header. If the date string is not valid, we ignore it
            # rather than raise an error to be generally consistent
            # with common servers such as Apache (which can usually
            # understand the screwy date string as a lucky side effect
            # of the way they parse it).
            try:    mod_since=long(DateTime(header).timeTime())
            except: mod_since=None
            if mod_since is not None:
                if self._p_mtime:
                    last_mod = long(self._p_mtime)
                else:
                    last_mod = long(0)
                if last_mod > 0 and last_mod <= mod_since:
                    # Set header values since apache caching will return Content-Length
                    # of 0 in response if size is not set here
                    RESPONSE.setHeader('Last-Modified', rfc1123_date(self._p_mtime))
                    RESPONSE.setHeader('Content-Type', content_type)
                    RESPONSE.setHeader('Content-Length', size)
                    RESPONSE.setStatus(304)
                    return 304
        return 0

    def index_html(self, REQUEST, RESPONSE, preview=0, original=0):
        """
        The default view of the contents of a File or Image.

        Returns the contents of the file or image.  Also, sets the
        Content-Type HTTP header to the objects content type.
        """
        if preview == 1 and self.has_preview:
            ct = self.prev_type
            size = self.prev_size
            data = self.prev_data
        elif original == 1 and self.orig_data <> None:
            ct = self.orig_type
            size = self.orig_size
            data = self.orig_data
        else:
            ct = self.content_type
            size = self.size
            data = self.data

        self.set_header(REQUEST, RESPONSE, ct, size)

        if self.precondition and hasattr(self,self.precondition):
            # Grab whatever precondition was defined and then 
            # execute it.  The precondition will raise an exception 
            # if something violates its terms.
            c=getattr(self,self.precondition)
            if hasattr(c,'isDocTemp') and c.isDocTemp:
                c(REQUEST['PARENTS'][1],REQUEST)
            else:
                c()

        RESPONSE.setHeader('Last-Modified', rfc1123_date(self._p_mtime))
        RESPONSE.setHeader('Content-Type', ct)
        RESPONSE.setHeader('Content-Length', size)

        # Don't cache the data itself, but provide an opportunity
        # for a cache manager to set response headers.
        self.ZCacheable_set(None)

        if type(data) is type(''): return data

        while data is not None:
            RESPONSE.write(data.data)
            data=data.next

        return ''
    
    
    def tag(self, preview=0, original=0, height=None, width=None, alt=None,
            scale=0, xscale=0, yscale=0, css_class=None, **args):
        """ Generate an HTML IMG tag for this image, with customization."""
        if preview == 1:
            x = self.prev_width
            y = self.prev_height
            u = self.absolute_url() + '/preview'
        elif original == 1:
            x = self.orig_width
            y = self.orig_height
            u = self.absolute_url() + '/original'
        else:
            x = self.width
            y = self.height
            u = self.absolute_url()
        
        if height is None: height=y
        if width is None:  width=x

        # Auto-scaling support
        xdelta = xscale or scale
        ydelta = yscale or scale

        if xdelta and width:
            width =  str(int(round(int(width) * xdelta)))
        if ydelta and height:
            height = str(int(round(int(height) * ydelta)))

        result='<img src="%s"' % (u)

        if alt is None:
            alt=getattr(self, 'title', '')
        result = '%s alt="%s"' % (result, alt)

        if height:
            result = '%s height="%s"' % (result, height)

        if width:
            result = '%s width="%s"' % (result, width)

        if not 'border' in map(string.lower, args.keys()):
            result = '%s border="0"' % result

        if css_class is not None:
            result = '%s class="%s"' % (result, css_class)

        for key in args.keys():
            value = args.get(key)
            result = '%s %s="%s"' % (result, key, value)

        return '%s />' % result

    
    def preview(self, REQUEST, RESPONSE):
        """ return a preview of the image """
        return self.index_html( REQUEST, RESPONSE, preview=1 )

    def prev_url(self):
        return self.getVirtualURL() + '/preview'
        
    def preview_html(self):
        """Makes an IMG-tag for the preview"""
        return self.tag(preview=1)

    def original(self, REQUEST, RESPONSE):
        """ return a preview of the image """
        return self.index_html( REQUEST, RESPONSE, original=1 )

    def original_url(self):
        return self.getVirtualURL() + '/original'

    def original_html(self):
        """Makes an IMG-tag for the original"""
        return self.tag(original=1)

    def manage_afterClone(self, item):
        Image.manage_afterClone(self, item)

    def manage_afterAdd(self, item, container):
        Image.manage_afterAdd(self, item, container)
        if hasattr(self, 'index_object'):
            self.index_object()

    def manage_beforeDelete(self, item, container):
        Image.manage_beforeDelete(self, item, container)
        self.unindex_object()

    manage_main = manage_editForm = DTMLFile('dtml/manage_editEasyImageForm', globals())

    manage_convertResizeForm = DTMLFile('dtml/manage_convertResizeEasyImageForm', globals())

    def manage_resize_image(self, maxx=0, maxy=0, ratio=1, REQUEST=None):
        """TTW: Resizing images"""
        if _PIL_is_present == 0:
            if REQUEST is not None:
                message = "Python Imaging Library is not installed. Resizing not supported."
                return self.manage_convertResizeForm(
                    self,
                    REQUEST,
                    manage_tabs_message=message,
                    management_view='Convert/Resize')
            return id


        self.data, self.content_type, self.width, self.height = self.makeimage(maxx, maxy, ratio, CONTENTTYPEMAP[self.content_type])

        if REQUEST is not None:
            message = "Image Resized."
            return self.manage_convertResizeForm(
                self,
                REQUEST,
                manage_tabs_message=message,
                management_view='Convert/Resize')
        return id

    
    def check_original(self):
        if self.orig_data == None:
            self.orig_data = self.data
            self.orig_type = self.content_type
            self.orig_size = self.size
            self.orig_width = self.width
            self.orig_height = self.height

    def makeimage(self, maxx=0, maxy=0, ratio=1, ftype='JPEG'):
        """Creates an image from the orginal with specified size."""

        if self.orig_data == None:
            tmpdata = self.data
        else:
            tmpdata = self.orig_data
            
        file = StringIO(str(tmpdata))
                
        if maxx <> 0 and maxy <> 0:
            im = PIL.Image.open(file)

            if ratio==1:            # keep aspect-ratio
                aspectx = float(im.size[0]) / float(maxx)
                aspecty = float(im.size[1]) / float(maxy)
                if aspectx > aspecty:
                    maxy = float(im.size[1]) / aspectx
                if aspectx < aspecty:
                    maxx = float(im.size[0]) / aspecty

            maxx = int(maxx)
            maxy = int(maxy)
            if im.mode!='RGB' and im.mode!='CMYK': im = im.convert("RGB")
            im.load()
            im = im.resize((maxx, maxy), PIL.Image.BICUBIC)
            
            newfile = StringIO()
            im.save(newfile, ftype, optimize=1)
            return newfile.getvalue(), TYPEINFOMAP[ftype]['content_type'], im.size[0], im.size[1]

        return None, '', 0, 0

    def get_conversion_types(self, content_type=None):
        
        if content_type == None: content_type = self.content_type
        try:
            filetype = CONTENTTYPEMAP[content_type]
        except:
            filetype = content_type

        conversiontypes = CONVERSIONMAP[filetype]
        res = []
        for ct in conversiontypes:
            res = res + [(ct, TYPEINFOMAP[ct]['name'])]
        
        return res

    def manage_convert_image(self, new_format='', REQUEST=None):
        """TTW: Converting images"""
        self.check_original() # Make sure the original is kept.

        if new_format<>'':
            if _PIL_is_present == 0:
                if REQUEST is not None:
                    message = "Python Imaging Library is not installed. Conversions not supported."
                    return self.manage_convertResizeForm(
                        self,
                        REQUEST,
                        manage_tabs_message=message,
                        management_view='Convert/Resize')
                return id
            else:
                self.data, self.content_type, self.width, self.height = self.makeimage(self.width, self.height, ftype=new_format)

        if REQUEST is not None:
            message = "Image converted."
            return self.manage_convertResizeForm(
                self,
                REQUEST,
                manage_tabs_message=message,
                management_view='Convert/Resize')
        return id


Globals.InitializeClass(EasyImage)

manage_addEasyImageForm=DTMLFile('dtml/manage_addEasyImageForm', globals())

#    """Add EasyImage"""
def manage_addEasyImage(self, id, file, title='', content_type='', REQUEST=None):
    """
    Add a new EasyImage object.

    Creates a new Image object 'id' with the contents of 'file'.
    """
    if not id and hasattr(file,'filename'):
        # generate id from filename and make sure, it has no 'bad' chars
        # TODO: Strip extension.
        id = os.path.splitext(file.filename)[0]
        id = id[max(string.rfind(id,'/'),
                string.rfind(id,'\\'),
                string.rfind(id,':')
               )+1:]
        title = title or string.capitalize(id)
 
    id=str(id)
    id = string.translate(id, TRANSMAP)
    title=str(title)
    content_type=str(content_type)

    self = self.this()
    self._setObject(id, EasyImage(id, file, title))

    imgObj = self._getOb(id)
    imgObj.manage_upload(file)
    if content_type:
        self._getOb(id).content_type=content_type

    if REQUEST is not None:
        try:    url=self.DestinationURL()
        except: url=REQUEST['URL1']
        REQUEST.RESPONSE.redirect('%s/manage_main' % url)
    return id

def initialize(context):
    """Initialize EasyImage Product"""

    context.registerClass (
            EasyImage,
            permission=EasyImageAdd,
            icon='icons/EasyImage.gif',
            constructors=(manage_addEasyImageForm, manage_addEasyImage),
            meta_type = EasyImage.meta_type
            )


